**General guidelines**

- Be sure to follow the [Security Releases general information](https://gitlab.com/gitlab-org/release/docs/blob/master/general/security/process.md) and [Security Releases as Release Manager](https://gitlab.com/gitlab-org/release/docs/blob/master/general/security/release-manager.md).
- Always work on [GitLab Security](https://gitlab.com/gitlab-org/security/gitlab) and [dev.gitlab.org](https://dev.gitlab.org/). Do not push anything to [GitLab Canonical](https://gitlab.com/gitlab-org/gitlab)

## Preparation

<% if critical? -%>
- [ ] Merge critical security merge requests using the UI.
  - Enable "Squash commits" option when merging.
<% else -%>
- [ ] Validate and merge security merge requests using ChatOps:
  - This will merge all security merge requests associated with a security implementation issue if all of them are valid.

   ```sh
   # In Slack:
   /chatops run release merge --security
   ```
<% end -%>

- [ ] If any merge requests could not be merged, investigate what needs to be done to resolve the issues. Do **not** proceed unless it has been determined safe to do so.

### Auto-Deploy - only for the latest version

The following steps should ideally be completed within one day.

- [ ] Temporarily disable the scheduled auto-deploy tasks via ChatOps:
   ```sh
   # In Slack
   /chatops run auto_deploy pause
   ```
- [ ] Ensure latest auto-deploy branches are synced across Canonical, Security, and Build:
   ```sh
   # In Slack
   /chatops run mirror status
   ```

<% if !critical? -%>
- [ ] Disable omnibus nightly builds by setting the schedules to inactive https://dev.gitlab.org/gitlab/omnibus-gitlab/pipeline_schedules
<% end -%>

- [ ] Manually cherry pick EACH security fix into the CURRENT auto-deploy branch, both GitLab and Omnibus. You can use the following script:

<details>
  <summary>Script to push to auto-deploy branch</summary>
  <code>

   ```sh
   # fetch both remotes
   git fetch origin
   git fetch security

   # sync current auto-deploy branch on security
   git checkout -b CURRENT_AUTO_DEPLOY_BRANCH --track security/CURRENT_AUTO_DEPLOY_BRANCH
   git pull origin CURRENT_AUTO_DEPLOY_BRANCH
   git push security

   # get a list of all the merge commits on security/master not available on origin/master
   git log origin/master..security/master --merges | grep "^commit"

   # cherry-pick each commit on that list in the current auto-deploy branch
   git cherry-pick -m 1 -x COMMIT_ID

   # push to security
   git push security
   ```
   </code>
</details>

- [ ] Tag a new auto-deploy version via ChatOps (no need to wait for green build), to create a deployer pipeline that will deploy to staging and create a QA issue:
   ```sh
   # In Slack
   /chatops run auto_deploy tag --security
   ```

## QA

- [ ] On the deployer pipeline, manually cancel the `gprd-cny-change-lock` from the deployer pipeline. This will prevent the automatic promotion to Canary.

- [ ] Once the deploy to staging is completed, notify the `@appsec-team` member so they can validate the security fixes on staging.

- [ ] Once the security fixes been validated on staging, retry the `gprd-cny-change-lock` job to  promote to Canary.

- [ ] If there are no issues reported on canary, proceed to promote the deployment to production.

## Packaging

- [ ] Ping the Security Engineers so they can get started with the blog post. The blog post should be done on `https://dev.gitlab.org/gitlab/www-gitlab-com`

- [ ] Ensure tests are green in CE and green in EE
   ```sh
   # In Slack:
   /chatops run release status --security
   ```

- [ ] Tag the security release:
  ```sh
  # In Slack:
  <% versions.each do |version| -%>
  /chatops run release tag --security <%= version.to_patch %>
  <% end %>
  ```

- [ ] Check that EE and CE packages are built:
  <% versions.each do |version| -%>
  - <%= version.to_patch %>: [EE packages](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus(ee: true) %>) and [CE packages](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus %>)
  <% end %>

## Deploy

- [ ] Verify that pre.gitlab.com is running the latest patch version
  - Check in Slack `#announcements` channel
  - Go to https://pre.gitlab.com/help

## Release

- [ ] This section should be done in coordination with the Security team, so **make sure to confirm with them before proceeding**
  ```sh
  # In Slack
  @appsec-team - We are ready to publish the security release packages for <%= version %>, please let us know if the blog post is ready.
  ```

- [ ] Publish the packages via ChatOps:

  ```sh
   # In Slack:
  <% versions.each do |version| -%>
  /chatops run publish <%= version %>
  <% end %>
  ```

- [ ] Create the versions:
  <% versions.each do |version| -%>
  - `<%= version %>` version on [version.gitlab.com](https://version.gitlab.com/versions/new?version=<%= version %>). **Be sure to mark it as a security release.**
  <% end %>

- [ ] Merge the blog post on `https://gitlab.com/gitlab-com/www-gitlab-com`
- [ ] In the `#content-updates` channel, share a link to the blog post.
- [ ] Enable omnibus nightly builds by setting the schedules to active https://dev.gitlab.org/gitlab/omnibus-gitlab/pipeline_schedules


### Sync

- [ ] Push `security/gitlab` `master`, and `auto-deploy` branches to all remotes.
- [ ] Push `security/gitlab-foss` `master` and `auto-deploy` branches to all remotes.
- [ ] Push `security/omnibus-gitlab` `master` and `auto-deploy` branches to all remotes.
- [ ] Push `security/gitaly` `master` branch to all remotes.
- [ ] Verify all remotes are synced:

   ```sh
   # In Slack
   /chatops run mirror status
   ```
### Auto-Deploy - only for the latest version

- [ ] Re-enable the scheduled auto-deploy tasks via ChatOps:
   ```sh
   # In Slack
   /chatops run auto_deploy unpause
   ```
- [ ] Create a new auto-deploy branch from `master` via ChatOps:
   ```sh
   # In Slack
   /chatops run auto_deploy prepare
   ```
